#include <config.h>
/*	$OpenBSD: flex.skl,v 1.11 2010/08/04 18:24:50 millert Exp $	*/

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /cvs/src/usr.bin/lex/flex.skl,v 1.11 2010/08/04 18:24:50 millert Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>
#include <errno.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define yywrap() 1
#define YY_SKIP_YYWRAP
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 59
#define YY_END_OF_BUFFER 60
static yyconst short int yy_accept[607] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   60,   47,   55,   54,   53,   46,   58,   32,
       48,   49,   32,   50,   47,   47,   47,   47,   52,   51,
       58,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   58,   47,   47,   55,   58,   42,   42,   42,   42,
       42,    2,   58,    1,   47,   47,   17,   16,   17,   16,
       16,   58,   58,   58,    3,    9,    8,    9,    4,    9,
        5,   58,   13,   13,   13,   11,   12,   47,    0,   55,
       53,    0,   57,    0,   47,   34,    0,   32,    0,   33,
        0,   45,   45,    0,   47,   47,    0,   47,   47,   47,

       47,    0,   37,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   47,   56,   47,   55,    0,    0,    0,
        0,    0,    0,   47,   47,   47,   47,   47,    2,    1,
        0,    1,   43,   43,    0,   47,   17,   17,   15,   14,
       15,    0,    0,    3,    9,    0,    6,    7,    9,    9,
       13,    0,   13,   13,    0,   10,    0,    0,    0,   34,
       34,    0,    0,   47,   47,   47,   47,   47,    0,    0,
       37,   37,   42,   39,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   47,    0,    0,    0,    0,    0,
        0,   47,   47,   47,   47,   47,    0,   47,   10,    0,

       47,   47,   47,   47,   47,   47,    0,   38,   38,   38,
        0,    0,   37,   37,   37,   37,   37,   37,   37,   42,
       42,   42,   42,   42,   42,   42,   42,   40,   42,   41,
       47,    0,    0,    0,    0,    0,    0,   47,   47,   47,
       47,   47,   47,   47,    0,    0,   38,   38,   38,    0,
       37,   37,    0,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,    0,   25,   42,   42,   42,   42,
       42,   42,   42,   42,   47,    0,    0,    0,    0,   47,
       47,   47,   47,   47,   47,   47,   47,    0,   38,    0,
       37,   37,   37,    0,    0,    0,   37,   37,   37,   37,

       37,   37,   37,   37,   37,   37,   37,   37,   37,   42,
       42,   42,   42,   42,   42,   42,   42,   47,    0,    0,
        0,   47,   47,   47,   35,   35,   35,    0,    0,   37,
       37,   37,   37,   37,   37,   37,    0,    0,    0,    0,
        0,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   42,   42,    0,   24,   42,
       42,   42,   42,    0,   23,    0,   26,   47,    0,    0,
        0,   47,   47,   47,   47,   35,   35,   35,   35,    0,
       37,    0,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,    0,    0,    0,   37,   37,   37,   37,

       37,   37,   37,   37,   37,   37,   37,   37,   37,   42,
       42,   42,   42,   42,   42,   44,    0,    0,    0,   47,
       20,   43,   36,   36,   36,   36,   37,    0,    0,    0,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,    0,    0,    0,    0,    0,   37,   37,
       37,   37,   37,   37,   37,   37,   42,   42,   42,   42,
        0,   22,    0,   27,    0,   20,    0,    0,   47,    0,
       47,   47,   47,   36,   36,   36,   36,    0,    0,    0,
        0,    0,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,

       37,   37,    0,   30,   42,   42,   42,    0,    0,    0,
       18,    0,   21,   20,    0,    0,    0,    0,    0,   20,
        0,   47,   47,   47,    0,    0,    0,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,    0,   28,   42,   42,   21,
        0,    0,   20,   47,   47,   47,   47,   47,    0,    0,
        0,    0,    0,   37,   37,   37,   37,   37,   37,   37,
       37,    0,   31,   42,    0,   47,   47,   47,   37,   37,
       37,   37,   37,   37,    0,   29,    0,    0,   19,   47,
       47,   47,   47,   47,   37,   37,   37,   37,   37,   35,

       35,   35,   35,   35,   35,    0
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    6,    1,    7,    1,    1,    8,
        9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
       19,   20,   21,   22,   22,   22,   23,   24,    1,    1,
       25,   26,   10,   27,   28,   29,   30,   31,   32,   29,
       33,   34,   35,   36,   36,   37,   36,   38,   39,   40,
       36,   41,   42,   43,   44,   45,   46,   47,   48,   36,
       10,   49,   10,    1,   50,    1,   51,   52,   53,   54,

       55,   56,   57,   57,   58,   57,   57,   59,   60,   61,
       62,   57,   57,   63,   64,   65,   66,   57,   57,   57,
       57,   57,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[67] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    7,    1,
        1,    8,    1,    9,   10,   11,   11,   11,   11,   11,
       11,   11,   11,   12,   13,    7,    1,   11,   11,   11,
       11,   11,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,   14,   15,
       16,   16,   16,   16,   16,   16,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15
    } ;

static yyconst short int yy_base[671] =
    {   0,
        0,   65,   67,   72,   99,  114,  162,  227,  292,  340,
       86,  125, 2840, 2790, 2836, 3665, 2833, 3665,  387,   70,
     3665, 3665, 2771, 3665,  136,  397,  133,  159, 2795, 3665,
     3665,  453, 2781,   33,  504, 2770, 2767, 2777, 2765, 2771,
     2754,  559,  170,   19,  165,  583,   38,   49, 2739,   68,
     2727,   81,  219, 2771,  305,   48,    0, 3665, 2761, 3665,
        0,  250,  639,  119,    0, 2709, 3665,  108, 3665,  112,
     3665,  140, 2699,   98,  121, 3665,  195, 2693,  661, 2739,
     2736, 2736, 3665,  227,  247,  300,  316,  152,  354, 2681,
      686,  373, 2670,  711,  352,  722, 2692, 2669,  375,  414,

      302, 2656,   57,  763,    0, 2628, 2625, 2614,  505, 2602,
     2606, 2599, 2601,  202, 3665,  153,  546, 2572, 2565, 2549,
     2537, 2524,  200,  110,  244,   28,  111,  252,  171, 2578,
      422, 2577,  565, 2529,  818,  262,    0, 2573,  179, 3665,
     3665,  599,  269,    0, 2513,  453, 3665, 3665, 2512,  548,
     2490, 2533,  206,  253,  323, 2535, 2524, 2513,  607,  615,
      306,  722,  586,  831,  867,  903,  939, 2499, 2456,  980,
      333, 1022, 1063,    0, 2430, 2394, 2363, 2364, 2374, 2369,
     2327, 2330, 2329, 2328,  266, 2289, 2283, 2272, 2274, 2279,
      409,  334, 2279,  145,  335,   83,  672,  278, 2327, 2325,

      627,  259, 1106, 1142,  741,  210, 2293, 2279,  683,  513,
     2275, 2271,  352,  747, 1178,  780,  788, 1220,  815, 2270,
      400,  325, 2261, 2258, 2248, 2246, 2242,    0, 2240,    0,
      489, 2223, 2213, 2198, 2211, 2198,  420,  407,  529,  490,
      491, 1263, 1299, 1335, 2235, 2234,  839, 2234, 2232, 2228,
     2226,  528,  848,  657,  856,  665, 1371,    0,  877, 1382,
      886,  894, 1424,  913,  570, 3665, 2208, 2197, 2201, 2178,
     2185, 2194, 2194, 2176,  558, 2169, 2152, 2150,  648,  626,
      530,  559,  923,  336, 1467, 1503,  964, 2171, 2140, 2139,
     2138, 1537,  551, 1000, 1041, 1082,  653,  694,  797, 1049,

      923, 1580,    0, 1116, 1591, 1090, 1008, 1633, 1125, 2121,
     2082,  747,  686, 2064, 2071,  786,  926,  905, 2080, 2033,
      679,  634,  544,  915, 1675, 1710, 1745, 2052, 2043, 2033,
     1150, 1781, 1158, 1133, 1822, 1197, 1166, 2028, 1239, 1273,
     1207,  950,  951,  962,  991, 1247, 1073, 1865,    0, 1283,
     1876, 1307, 1315, 1918, 1323, 1987, 1968, 1188, 3665, 1967,
     1951, 1929, 1913, 1286, 3665, 1336, 3665,  707, 1897, 1889,
      786,  930,  764, 1298, 1358, 1041, 1960, 1995, 1400, 1927,
     1879, 1348,  708, 1406, 1348, 2031,    0,  559, 2042, 1441,
     1449, 2083, 1477, 1487, 1513, 1523, 1230, 1290, 1458, 1548,

     1557, 1602, 2126,    0, 1613, 2137, 1650, 1565, 1660, 1806,
     1779, 1680, 1675, 1359, 1406, 1626, 1601, 1577,  897,  938,
     1695, 1589, 2180, 2216, 2252, 2288, 1611, 1686, 1720, 1731,
     1563, 1478, 1504, 1694, 1524, 2324,    0,  617, 2335, 1753,
     1761, 2376, 1769, 1798, 1550, 1808, 1841, 1851, 1335, 1358,
     1887,  714,  825, 2419,    0,  926, 1407, 1468, 1430, 1431,
     1547, 3665, 1616, 3665, 1381, 1731, 1045, 1512, 1575, 1908,
     1913, 1970, 1498, 2429, 2465, 1947, 1611, 1981, 1264, 2006,
     2016, 2061, 1198, 1181, 1732, 1782, 2067, 1842, 2501,    0,
     1181, 2512, 2100, 1904, 2553, 2110, 2155, 2164, 2189, 1769,

     1142, 1232, 1634, 3665, 1699, 1095, 1077, 1025, 1046, 1306,
     3665,  384,  981, 2211, 2218, 2238, 2243, 2263, 2288, 2249,
     2307, 2596, 2632, 2668, 2304, 2354, 2395,  983,  894, 1902,
     1928, 2362, 1929, 2704,    0, 1428, 2715, 2403, 2437, 2445,
      867, 2454, 2474, 2483,  831, 1982, 3665, 1983,  782, 3665,
     1511, 2489, 2529, 2537, 1895, 2758, 2794, 2573, 2579,  650,
     2607, 2617, 2642,  629,  525, 1931,  447,  347, 2650,    0,
     1528, 2019, 3665, 2044, 1805, 2830, 2866, 2902, 2676, 2684,
     2692,  323,    0,  316, 2067, 3665,  166, 1845, 3665, 2733,
     1945, 2938, 2974, 2743, 3665, 2767, 2777, 2658, 3665, 2805,

     2813, 2847,   63, 2855, 2881, 3665, 3023, 3039, 3055, 3071,
     3087, 3103, 3119, 3135, 3151, 3157, 3173, 3189, 2025, 3205,
     3221, 3237, 3253, 3269, 3285, 3301, 3307, 3314, 3330, 3346,
     3352, 3359, 3365, 3371, 3377, 3384, 3390, 3396, 3402, 3409,
     3417, 3423, 3429, 3435, 3442, 3450, 3456, 3462, 3469, 3477,
     3483, 3491, 3498, 3506, 3512, 3520, 3527, 3535, 3551, 3567,
     3583, 3589, 3597, 3604, 3610, 3618, 3624, 3632, 3648, 1295
    } ;

static yyconst short int yy_def[671] =
    {   0,
      606,    1,    1,    1,  607,  607,  608,  608,  609,  609,
      610,  610,  606,  611,  606,  606,  606,  606,  612,  613,
      606,  606,  614,  606,  615,  611,   26,   26,  616,  606,
      606,  606,   32,   32,   32,   35,   35,   35,   35,   35,
       35,  611,   26,  611,  606,  612,   32,   32,   35,   35,
       35,  606,  606,  606,  617,  611,  618,  606,  618,  606,
      618,  606,  612,  606,  619,  620,  606,  620,  606,  620,
      606,  621,  622,  622,  622,  606,  606,  611,  611,  606,
      606,  623,  606,  624,  606,  613,  606,  625,  613,  614,
      614,  615,  626,  611,  611,   26,  616,   96,   96,   96,

       96,  627,  628,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,  611,  606,  611,  606,  606,  606,  606,
      606,  606,  623,  611,   96,  611,  611,  611,  606,  606,
      606,  606,  617,  629,  611,  611,  618,  618,  606,  606,
      606,  624,  606,  619,  620,  620,  606,  606,  620,  620,
      622,  606,  622,  622,  606,  606,  623,  630,  606,  606,
      625,  625,  606,  611,  611,  611,   96,  167,  631,  606,
      632,  606,  104,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,  611,  606,  606,  606,  606,  606,
      623,  611,  167,  611,  611,  611,  606,  611,  606,  630,

      611,  611,  611,  611,  611,  611,  633,  634,  634,  209,
      635,  634,  636,  172,  606,  215,  215,  606,  215,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
      611,  606,  606,  606,  606,  606,  623,  611,  611,  611,
      611,  611,  611,  611,  606,  637,  637,  247,  637,  638,
      639,  640,  606,  641,  218,  641,  641,  257,  641,  606,
      260,  260,  606,  260,  606,  606,   35,   35,   35,   35,
       35,   35,   35,   35,  611,  606,  606,  606,  623,  611,
      611,  611,  611,  611,  611,  611,  611,  642,  642,  643,
      644,  606,  606,  606,  606,  606,  645,  645,  646,  263,

      646,  646,  302,  646,  606,  305,  305,  606,  305,   35,
       35,   35,   35,   35,   35,   35,   35,  611,  606,  606,
      623,  611,  611,  611,  611,  611,  611,  606,  647,  648,
      292,  606,  332,  332,  606,  332,  606,  606,  606,  606,
      606,  606,  649,  649,  650,  308,  650,  650,  348,  650,
      606,  351,  351,  606,  351,   35,   35,  606,  606,   35,
       35,   35,   35,  606,  606,  606,  606,  611,  606,  606,
      623,  611,  611,  611,  611,  611,  611,  611,  611,  606,
      651,  606,  652,  335,  652,  652,  386,  386,  606,  389,
      389,  606,  389,  606,  606,  606,  606,  653,  653,  654,

      354,  654,  654,  403,  654,  606,  406,  406,  406,   35,
       35,   35,   35,   35,   35,  611,  606,  606,  623,  611,
      611,  611,  611,  611,  611,  611,  606,  606,  606,  606,
      655,  655,  656,  392,  656,  656,  436,  436,  606,  439,
      439,  606,  439,  606,  606,  606,  606,  606,  606,  657,
      657,  658,  658,  658,  454,  454,   35,   35,   35,   35,
      606,  606,  606,  606,  606,  606,  659,  623,  611,  660,
      661,  611,  611,  611,  611,  611,  611,  606,  606,  606,
      606,  606,  606,  662,  662,  663,  442,  663,  663,  489,
      489,  606,  492,  492,  606,  492,  606,  606,  606,  606,

      664,  664,  606,  606,   35,   35,   35,  606,  659,  659,
      606,  623,  611,  660,  660,  660,  660,  606,  660,  661,
      661,  611,  611,  611,  606,  606,  606,  606,  665,  665,
      666,  495,  666,  666,  534,  534,  606,  537,  537,  537,
      606,  606,  606,  606,  606,  606,  606,   35,   35,  606,
      623,  606,  606,  611,  611,  611,  611,  611,  606,  606,
      606,  606,  606,  606,  667,  667,  668,  668,  668,  569,
      569,  606,  606,   35,  669,  611,  611,  611,  606,  606,
      606,  606,  670,  670,  606,  606,  669,  669,  606,  611,
      611,  611,  611,  611,  606,  606,  606,  606,  606,  611,

      611,  611,  611,  611,  611,    0,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606
    } ;

static yyconst short int yy_nxt[3732] =
    {   0,
       14,   15,   16,   17,   18,   19,   20,   21,   22,   14,
       23,   24,   14,   14,   25,   26,   27,   28,   26,   26,
       26,   26,   26,   29,   30,   31,   14,   32,   33,   33,
       33,   34,   35,   35,   35,   35,   36,   37,   35,   38,
       39,   40,   41,   35,   35,   35,   35,   35,   42,   14,
       43,   43,   43,   43,   43,   43,   14,   14,   14,   14,
       14,   14,   14,   44,   14,   14,   45,   79,   52,  105,
       46,  170,   53,   52,  105,   87,   79,   53,   54,  107,
      172,   55,  129,   54,  116,  105,   55,   74,   16,   75,
       76,  194,  130,   88,   47,   48,   79,  124,   49,  153,

       15,   58,   59,  125,   60,   50,  111,   35,   51,   35,
       60,   79,   35,  136,   35,   15,   58,   59,   89,   60,
      143,  115,   60,   61,  154,   60,   74,   16,   75,   76,
       56,   79,  147,  127,   77,   56,  148,   60,   61,   93,
       93,  150,  115,   93,   93,  238,  152,   62,   99,   99,
       99,   99,   99,   99,   99,   99,  146,   87,   79,   79,
      146,   93,   62,   15,   16,   17,  117,   63,  589,  152,
      192,  195,  129,   77,  100,  100,  100,  100,  100,  101,
      143,  115,  130,   78,   94,   98,   98,   98,   98,   98,
       98,   98,   98,   79,  118,  119,  155,  156,  120,  151,

      162,   79,   83,  143,  115,  121,  185,  153,  122,  238,
       64,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   15,   16,
       17,  131,   63,   97,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       79,  139,  115,  140,  152,  141,  154,   78,   79,  140,
      191,  141,   85,   85,   85,   85,   85,   85,   85,   85,
      143,  115,  201,  141,  141,   64,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   15,   16,   17,   67,   63,  141,  193,

       79,  152,   68,   69,   70,  606,  196,   79,  134,  134,
       79,  606,  134,  134,   79,  198,   71,  168,  168,  168,
      168,  168,  168,  606,  155,  156,   79,  231,  159,  382,
      134,  160,  160,  160,  160,  160,  160,  160,  160,  241,
       72,   15,   16,   17,   67,   63,  532,  170,   89,  283,
       68,   69,   70,  135,  162,   86,  214,   86,   86,  267,
      606,   86,   86,  268,   71,   86,  170,  164,  165,  166,
      164,  164,  164,  164,  164,  214,   93,   93,   86,   86,
       93,   93,   79,   79,   79,  240,   83,  238,   72,   83,
      168,  168,  168,  168,  168,  168,  168,  168,   93,   84,

       79,  265,   85,   85,   85,   85,   85,   85,   85,   85,
       95,   83,   96,   96,   96,   96,   96,   96,   96,   96,
       97,   94,   83,  266,   98,   98,   98,   98,   98,  168,
      168,  168,  168,  168,  168,  168,  168,   85,   85,   85,
       85,   85,   85,   85,   85,   79,  551,   98,   98,   98,
       98,   98,   98,   78,  145,   79,  280,  145,  145,   78,
      382,  237,   78,   78,  145,   78,   78,   78,  104,  104,
      104,  104,  104,  104,  104,  104,   97,  145,  279,   78,
      104,  104,  104,  104,  104,  105,  105,  105,  105,  106,
      105,  105,  105,  105,  105,  105,  105,  105,  105,  105,

      105,   79,  105,   98,   98,   98,   98,   98,   98,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,  105,
      105,  105,  105,  105,  105,  105,  105,  606,  249,  249,
      249,  105,  105,  105,  105,  105,  177,   79,   79,   79,
      105,  178,  170,  275,  179,  282,  180,  117,  532,  143,
      115,  214,   97,  238,   78,   78,   78,   78,   78,   78,
      114,  115,   78,   78,   78,  170,   78,   78,  134,  134,
       78,  265,  134,  134,  214,  118,  119,   79,   79,  120,
      431,  431,   78,   78,   78,   83,  121,   93,  323,  122,
      134,   93,   79,  266,  281,   84,  146,   93,   85,   85,

       85,   85,   85,   85,   85,   85,   79,   79,  373,   93,
       93,  318,  324,  135,  606,  606,  606,  606,  606,  606,
      606,  606,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  484,  484,
      123,   83,  242,  243,  244,  242,  242,  242,  242,  242,
       83,  142,  487,  322,  606,  606,  606,  606,  606,  606,
      606,  606,   78,  559,   78,   78,   78,  170,   78,   78,
      253,  170,   78,  134,   79,   79,  255,  134,  606,  170,
      255,   83,   79,  134,   78,   78,   78,   90,  255,   90,
       90,   90,  372,   90,   90,  134,  134,   90,  247,  247,

      248,  249,  249,  249,  249,  249,  211,  253,  170,   90,
       90,   90,   92,  321,   78,   78,   92,  255,   78,   78,
      360,  382,   92,  161,  361,  161,  161,  253,  170,  161,
      161,  384,  371,  161,   92,   92,   78,  167,  167,  167,
      167,  167,  167,  167,  167,  161,  161,  161,  358,  167,
      167,  167,  167,  167,  201,   79,  202,  202,  202,  202,
      202,  202,  219,  219,  219,  219,  219,  219,  219,  219,
      359,  416,  167,  167,  167,  167,  167,  167,  173,  173,
      173,  173,  173,  173,  173,  173,   97,  364,   83,   79,
      173,  173,  173,  173,  173,  257,  257,  257,  257,  257,

      257,  257,  257,  258,  258,  258,  258,  258,  259,  365,
      253,  170,   79,  167,  167,  167,  167,  167,  167,  133,
      300,   78,   78,  133,  574,   78,   78,  421,  606,  133,
      256,  256,  256,  256,  256,  256,  256,  256,  606,  170,
      419,  133,  133,   78,  201,  170,  202,  202,  202,  202,
      202,  202,  202,  202,  289,  289,  289,  289,  289,  289,
      289,  289,  211,  294,  295,  296,  294,  294,  294,  294,
      294,  264,  264,  264,  264,  264,  264,  264,  264,   79,
      201,  170,  203,  203,  203,  203,  203,  203,  203,  203,
      253,  170,  298,  298,  298,  298,  298,  298,  467,   83,

      255,  302,  302,  302,  302,  302,  302,  302,  302,  303,
      303,  303,  303,  303,  304,   79,  201,  487,  204,  204,
      204,  204,  204,  205,  202,  202,  606,  366,  301,  301,
      301,  301,  301,  301,  301,  301,  606,  170,  325,  326,
      327,  325,  325,  325,  325,  325,  300,  501,  501,  367,
      468,   79,   78,   79,  206,  206,  206,  206,  206,  206,
      206,  206,  368,   79,  170,  170,  206,  206,  206,  206,
      206,   79,  374,  255,  300,  253,  170,  283,   79,  284,
      284,  284,  284,  284,  284,  300,   79,  420,  469,  206,
      206,  206,  206,  206,  206,  208,  209,  210,  210,  210,

      210,  210,  210,  211,  253,  170,  434,  212,  212,  212,
      212,  212,   79,  337,  346,  338,  338,  338,  338,  338,
      338,  338,  338,  349,  349,  349,  349,  349,  350,   79,
      212,  212,  212,  212,  212,  212,  170,  215,  216,  217,
      215,  215,  215,  215,  215,  218,  510,  511,  511,  219,
      219,  219,  219,  219,  337,  375,  339,  339,  339,  339,
      339,  339,  339,  339,  309,  309,  309,  309,  309,  309,
      309,  309,  219,  219,  219,  219,  219,  219,  220,  220,
      220,  220,  220,  220,  220,  220,  606,  170,  550,   79,
      220,  220,  220,  220,  220,  337,  346,  340,  340,  340,

      340,  340,  341,  338,  338,  348,  348,  348,  348,  348,
      348,  348,  348,  206,  206,  206,  206,  206,  206,  201,
      549,  202,  202,  202,  202,  202,  202,  202,  202,  253,
      170,  344,  344,  344,  344,  344,  344,  548,  606,  300,
      347,  347,  347,  347,  347,  347,  347,  347,  387,  387,
      387,  387,  387,  388,   79,  201,  170,  202,  202,  202,
      202,  202,  202,  202,  202,  336,  336,  336,  336,  336,
      336,  336,  336,  386,  386,  386,  386,  386,  386,  386,
      386,  394,  395,  396,  394,  394,  394,  394,  394,  358,
       79,  253,  170,  254,  254,  254,  254,  254,  254,  254,

      254,  255,  529,  529,  434,  256,  256,  256,  256,  256,
      606,  359,  385,  385,  385,  385,  385,  385,  385,  385,
      337,  384,  338,  338,  338,  338,  338,  338,  256,  256,
      256,  256,  256,  256,  170,  260,  261,  262,  260,  260,
      260,  260,  260,  263,  170,  253,  170,  264,  264,  264,
      264,  264,  337,  300,  338,  338,  338,  338,  338,  338,
      338,  338,  355,  355,  355,  355,  355,  355,  355,  355,
      264,  264,  264,  264,  264,  264,  283,  478,  284,  284,
      284,  284,  284,  284,  284,  284,  337,  364,  338,  338,
      338,  338,  338,  338,  338,  338,  253,  170,  399,  399,

      399,  399,  399,  399,  170,  599,  346,  510,  511,  365,
      599,   79,  283,  346,  285,  285,  285,  285,  285,  285,
      285,  285,  403,  403,  403,  403,  403,  403,  403,  403,
      404,  404,  404,  404,  404,  405,  606,  366,  402,  402,
      402,  402,  402,  402,  402,  402,   79,   79,  283,  170,
      286,  286,  286,  286,  286,  287,  284,  284,  346,  367,
      461,  606,  422,  428,  429,  430,  428,  428,  428,  428,
      428,  384,  170,  423,  424,  425,  426,  423,  423,  423,
      423,  401,  462,   79,  253,  170,  298,  298,  298,  298,
      298,  298,  298,  298,  255,  253,  170,  299,  299,  299,

      299,  299,  299,  299,  299,  300,   79,  463,  503,  301,
      301,  301,  301,  301,  375,  376,  376,  376,  376,  376,
      376,  393,  393,  393,  393,  393,  393,  393,  393,  464,
      504,  508,  301,  301,  301,  301,  301,  301,  170,  305,
      306,  307,  305,  305,  305,  305,  305,  308,   79,  565,
      565,  309,  309,  309,  309,  309,  436,  436,  436,  436,
      436,  436,  436,  436,  437,  437,  437,  437,  437,  438,
      507,  253,  170,  506,  309,  309,  309,  309,  309,  309,
      283,  346,  284,  284,  284,  284,  284,  284,  284,  284,
      606,  382,  435,  435,  435,  435,  435,  435,  435,  435,

      444,  384,  445,  445,  445,  445,  445,  445,  445,  445,
      505,  472,  575,   83,   83,   79,  283,  382,  284,  284,
      284,  284,  284,  284,  284,  284,  444,  434,  446,  446,
      446,  446,  446,  446,  446,  446,  444,  606,  447,  447,
      447,  447,  447,  448,  445,  445,   79,  434,  461,  583,
      583,   79,  332,  333,  334,  332,  332,  332,  332,  332,
      335,  253,  170,  444,  336,  336,  336,  336,  336,  512,
      462,  401,  409,  409,  409,  409,  409,  409,  409,  409,
      455,  455,  455,  455,  455,  456,  384,  336,  336,  336,
      336,  336,  336,  253,  170,  344,  344,  344,  344,  344,

      344,  344,  344,  300,  253,  170,  345,  345,  345,  345,
      345,  345,  345,  345,  346,  606,  170,  463,  347,  347,
      347,  347,  347,   79,  472,  401,  253,  170,  451,  451,
      451,  451,  451,  451,  331,  503,  401,   79,  513,  464,
      466,  347,  347,  347,  347,  347,  347,  170,  351,  352,
      353,  351,  351,  351,  351,  351,  354,  504,  465,   79,
      355,  355,  355,  355,  355,  454,  454,  454,  454,  454,
      454,  454,  454,  606,   79,  453,  453,  453,  453,  453,
      453,  453,  453,  355,  355,  355,  355,  355,  355,  375,
      376,  376,  376,  376,  376,  376,  376,  376,  470,  478,

      546,  479,  479,  479,  479,  479,  479,  479,  479,  443,
      443,  443,  443,  443,  443,  443,  443,  460,  470,  459,
      470,  471,  547,   79,  375,  377,  377,  377,  377,  377,
      377,  377,  377,  478,  470,  480,  480,  480,  480,  480,
      480,  480,  480,   79,  478,  382,  481,  481,  481,  481,
      481,  482,  479,  479,  470,  434,  470,  470,   79,  375,
      378,  378,  378,  378,  378,  379,  376,  376,  489,  489,
      489,  489,  489,  489,  489,  489,  490,  490,  490,  490,
      490,  491,  606,  170,  488,  488,  488,  488,  488,  488,
      488,  488,  401,   79,  382,  382,  383,  383,  383,  383,

      383,  383,  383,  383,  384,  487,  588,  589,  385,  385,
      385,  385,  385,  497,  498,  499,  497,  497,  497,  497,
      497,  444,  458,  445,  445,  445,  445,  445,  445,  445,
      445,  385,  385,  385,  385,  385,  385,  389,  390,  391,
      389,  389,  389,  389,  389,  392,  588,  589,  457,  393,
      393,  393,  393,  393,  444,  606,  445,  445,  445,  445,
      445,  445,  445,  445,  444,  487,  445,  445,  445,  445,
      445,  445,  393,  393,  393,  393,  393,  393,  253,  170,
      399,  399,  399,  399,  399,  399,  399,  399,  346,  253,
      170,  400,  400,  400,  400,  400,  400,  400,  400,  401,

      253,  170,  331,  402,  402,  402,  402,  402,  554,  515,
      401,  516,  517,  518,  515,  382,  516,  517,  518,  535,
      535,  535,  535,  535,  536,  487,  402,  402,  402,  402,
      402,  402,  170,  406,  407,  408,  406,  406,  406,  406,
      406,  382,  606,   79,  382,  409,  409,  409,  409,  409,
      251,  532,  532,  418,  532,  417,  519,  415,  590,  414,
      472,  521,  473,  473,  473,  473,  473,  473,  409,  409,
      409,  409,  409,  409,  375,  376,  376,  376,  376,  376,
      376,  376,  376,  546,  572,  522,  523,  524,  522,  522,
      522,  522,  522,   79,  413,   79,  525,  526,  527,  525,

      525,  525,  525,  525,  412,  547,  573,  411,   79,  375,
      376,  376,  376,  376,  376,  376,  376,  376,   79,  478,
      572,  479,  479,  479,  479,  479,  479,  479,  479,  478,
      410,  479,  479,  479,  479,  479,  479,  479,  479,  144,
      144,  337,  573,   79,  382,  585,  432,  432,  432,  432,
      432,  432,  432,  432,  384,  382,  331,  433,  433,  433,
      433,  433,  433,  433,  433,  434,  251,  586,  585,  435,
      435,  435,  435,  435,  478,  211,  479,  479,  479,  479,
      479,  479,  496,  496,  496,  496,  496,  496,  496,  496,
      586,  370,  435,  435,  435,  435,  435,  435,  439,  440,

      441,  439,  439,  439,  439,  439,  442,  369,  363,  362,
      443,  443,  443,  443,  443,  534,  534,  534,  534,  534,
      534,  534,  534,  606,  357,  533,  533,  533,  533,  533,
      533,  533,  533,  443,  443,  443,  443,  443,  443,  253,
      170,  451,  451,  451,  451,  451,  451,  451,  451,  401,
      253,  170,  452,  452,  452,  452,  452,  452,  452,  452,
      356,  331,  251,  211,  453,  453,  453,  453,  453,  170,
      541,  541,  541,  541,  541,  541,  541,  541,  170,  542,
      542,  542,  542,  542,  542,  542,  542,  453,  453,  453,
      453,  453,  453,  472,  211,  473,  473,  473,  473,  473,

      473,  473,  473,  170,  543,  543,  543,  543,  543,  544,
      541,  541,  606,  276,  606,  606,  606,  320,  319,  515,
      317,  516,  517,  518,  316,  315,  314,  313,   79,  472,
      312,  474,  474,  474,  474,  474,  474,  474,  474,  606,
      311,  516,  517,  518,  606,  310,  606,  606,  518,  292,
      606,  251,  606,  606,  606,  211,  288,  211,  103,  519,
      276,  278,  276,  277,   79,  472,  519,  475,  475,  475,
      475,  475,  476,  477,  477,  552,  276,  274,  553,  553,
      553,  553,  553,  553,  553,  553,  519,  273,  272,  271,
      270,  519,  269,   97,  211,  514,  514,  521,  251,  514,

       79,  472,  211,  477,  477,  477,  473,  473,  473,  473,
      473,  514,  514,  514,  520,  520,  103,  559,  520,  560,
      560,  560,  560,  560,  560,  560,  560,   83,  199,  239,
      520,  520,  520,  236,  235,  234,   79,  382,  233,  485,
      485,  485,  485,  485,  485,  485,  485,  434,  382,  232,
      486,  486,  486,  486,  486,  486,  486,  486,  487,  230,
      229,  228,  488,  488,  488,  488,  488,  559,  227,  561,
      561,  561,  561,  561,  561,  561,  561,  540,  540,  540,
      540,  540,  540,  540,  540,  488,  488,  488,  488,  488,
      488,  492,  493,  494,  492,  492,  492,  492,  492,  495,

      226,  225,  224,  496,  496,  496,  496,  496,  559,  223,
      562,  562,  562,  562,  562,  563,  560,  560,  569,  569,
      569,  569,  569,  569,  569,  569,  496,  496,  496,  496,
      496,  496,  253,  170,  502,  502,  502,  502,  502,  502,
      502,  502,  472,  222,  473,  473,  473,  473,  473,  473,
      473,  473,  570,  570,  570,  570,  570,  571,  606,  221,
      568,  568,  568,  568,  568,  568,  568,  568,  170,  541,
      541,  541,  541,  541,  541,  541,  541,   79,  472,  103,
      473,  473,  473,  473,  473,  473,  473,  473,  170,  541,
      541,  541,  541,  541,  541,  541,  541,  170,  541,  541,

      541,  541,  541,  541,  553,  553,  553,  553,  553,  553,
      553,  553,   95,   79,  382,   83,  530,  530,  530,  530,
      530,  530,  530,  530,  487,  382,   83,  531,  531,  531,
      531,  531,  531,  531,  531,  532,  199,  151,  152,  533,
      533,  533,  533,  533,  553,  553,  553,  553,  553,  553,
      553,  553,  576,  577,  578,  576,  576,  576,  576,  576,
      146,  146,  533,  533,  533,  533,  533,  533,  537,  538,
      539,  537,  537,  537,  537,  537,  138,  197,  132,  132,
      540,  540,  540,  540,  540,   79,  554,  190,  555,  555,
      555,  555,  555,  555,  579,  580,  581,  579,  579,  579,

      579,  579,  189,  540,  540,  540,  540,  540,  540,  554,
      188,  555,  555,  555,  555,  555,  555,  555,  555,  187,
      559,   79,  560,  560,  560,  560,  560,  560,  560,  560,
      559,  186,  560,  560,  560,  560,  560,  560,  560,  560,
      184,  183,  182,  181,   79,  554,  176,  556,  556,  556,
      556,  556,  556,  556,  556,  559,  175,  560,  560,  560,
      560,  560,  560,  382,  174,  584,  584,  584,  584,  584,
      584,  584,  584,  595,  595,  595,  595,  595,  595,  103,
       79,  554,   78,  557,  557,  557,  557,  557,  558,  555,
      555,  595,  595,  595,  595,  595,  595,  595,  595,  596,

      596,  596,  596,  596,  596,  596,  596,  597,  597,  597,
      597,  597,  598,  595,  595,  103,   79,  382,  163,  566,
      566,  566,  566,  566,  566,  566,  566,  532,  382,   91,
      567,  567,  567,  567,  567,  567,  567,  567,   83,   81,
       80,   79,  568,  568,  568,  568,  568,  152,  600,  601,
      602,  600,  600,  600,  600,  600,  590,  146,  591,  591,
      591,  591,  591,  591,  138,  568,  568,  568,  568,  568,
      568,  554,  132,  555,  555,  555,  555,  555,  555,  555,
      555,   79,  595,  595,  595,  595,  595,  595,  595,  595,
      128,   79,  595,  595,  595,  595,  595,  595,  595,  595,

      126,  113,  112,  111,  110,  109,   79,  554,  108,  555,
      555,  555,  555,  555,  555,  555,  555,  105,  103,   91,
      603,  603,  603,  603,  603,  603,  603,  603,  600,  600,
      600,  600,  600,  600,  600,  600,   81,   80,   79,  606,
      606,  606,   79,  590,  606,  591,  591,  591,  591,  591,
      591,  591,  591,   79,  606,  606,  606,  606,  606,  606,
      606,   79,  604,  604,  604,  604,  604,  605,  603,  603,
      603,  603,  603,  603,  603,  603,  603,  603,   79,  590,
      606,  592,  592,  592,  592,  592,  592,  592,  592,  606,
      606,  606,  606,  606,  606,   79,  603,  603,  603,  603,

      603,  603,  606,   79,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,   79,  590,  606,  593,  593,  593,
      593,  593,  594,  591,  591,  606,  606,  606,  606,   79,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
       79,  590,  606,  591,  591,  591,  591,  591,  591,  591,
      591,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,   79,  590,  606,  591,
      591,  591,  591,  591,  591,  591,  591,  606,  606,  606,

      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,   79,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
       66,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   78,  606,  606,
      606,  606,  606,  606,  606,   78,   78,   78,  606,  606,

       78,   78,   78,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   86,
      606,  606,  606,  606,   86,  606,  606,   86,   86,   86,
       86,  606,   86,   86,   86,   90,  606,  606,  606,  606,
      606,  606,  606,   90,   90,   90,  606,  606,   90,   90,
       90,   92,  606,  606,   92,   92,  606,   92,  606,   92,
       92,   92,  606,  606,   92,   92,   92,  102,  102,  606,
      606,  606,  102,  133,  606,  606,  133,  133,  606,  133,
      606,  133,  133,  133,  606,  606,  133,  133,  133,  137,
      606,  606,  137,  137,  606,  137,  606,  137,  137,  137,

      606,  137,  606,  137,  137,  145,  606,  606,  145,  606,
      606,  145,  606,  145,  145,  145,  145,  606,  145,  145,
      145,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  151,  151,  606,
      151,  606,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  158,
      158,  606,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  161,  606,  606,  606,  606,
      161,  606,  606,  161,  161,  161,  606,  606,  161,  161,

      161,   93,  606,  606,   93,   93,  606,   93,  606,   93,
       93,   93,  606,  606,   93,   93,   93,  169,  169,  606,
      606,  606,  169,  171,  171,  171,  606,  606,  606,  171,
      134,  606,  606,  134,  134,  606,  134,  606,  134,  134,
      134,  606,  606,  134,  134,  134,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  207,  207,  606,  606,  606,  207,  213,  213,
      213,  606,  606,  606,  213,  245,  245,  606,  606,  606,
      245,  246,  246,  606,  606,  606,  246,  250,  250,  606,
      606,  606,  250,  252,  252,  252,  606,  606,  606,  252,

      288,  288,  606,  606,  606,  288,  290,  290,  606,  606,
      606,  290,  291,  291,  606,  606,  606,  291,  293,  293,
      293,  606,  606,  606,  293,  297,  297,  297,  297,  606,
      606,  606,  297,  328,  328,  606,  606,  606,  328,  329,
      329,  606,  606,  606,  329,  330,  330,  606,  606,  606,
      330,  342,  342,  342,  606,  606,  606,  342,  343,  343,
      343,  343,  606,  606,  606,  343,  380,  380,  606,  606,
      606,  380,  381,  381,  606,  606,  606,  381,  397,  397,
      397,  606,  606,  606,  397,  398,  398,  398,  398,  606,
      606,  606,  398,  427,  427,  606,  606,  606,  427,  431,

      606,  431,  431,  606,  606,  606,  431,  449,  449,  449,
      606,  606,  606,  449,  450,  450,  450,  450,  606,  606,
      606,  450,  483,  483,  606,  606,  606,  483,  484,  606,
      484,  484,  606,  606,  606,  484,  500,  500,  500,  606,
      606,  606,  500,  501,  501,  501,  606,  606,  606,  606,
      501,  509,  509,  509,  509,  509,  509,  509,  509,  509,
      509,  509,  509,  509,  509,  509,  509,  514,  514,  606,
      514,  514,  514,  606,  606,  514,  514,  514,  606,  606,
      514,  514,  514,  520,  520,  606,  520,  520,  520,  606,
      606,  520,  520,  520,  606,  606,  520,  520,  520,  528,

      528,  606,  606,  606,  528,  529,  606,  529,  529,  606,
      606,  606,  529,  545,  545,  606,  606,  606,  606,  545,
      564,  564,  606,  606,  606,  564,  565,  606,  565,  565,
      606,  606,  606,  565,  582,  582,  606,  606,  606,  582,
      583,  606,  583,  606,  606,  606,  606,  583,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  587,  587,   13,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,

      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606
    } ;

static yyconst short int yy_chk[3732] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    2,   44,    3,   34,
        2,  103,    3,    4,   47,   20,  126,    4,    3,   34,
      103,    3,   52,    4,   44,   48,    4,   11,   11,   11,
       11,  126,   52,   20,    2,    2,   56,   47,    2,   74,

        5,    5,    5,   48,    5,    2,   50,    3,    2,    3,
        5,  603,    4,   56,    4,    6,    6,    6,   20,    6,
       64,   64,    5,    5,   75,    6,   12,   12,   12,   12,
        3,  196,   68,   50,   11,    4,   70,    6,    6,   25,
       25,   72,   72,   25,   25,  196,   74,    5,   27,   27,
       27,   27,   27,   27,   27,   27,   68,   88,  124,  127,
       70,   25,    6,    7,    7,    7,   45,    7,  587,   75,
      124,  127,  129,   12,   28,   28,   28,   28,   28,   28,
      139,  139,  129,   43,   25,   43,   43,   43,   43,   43,
       43,   43,   43,  194,   45,   45,   77,   77,   45,   77,

       88,  116,  123,  114,  114,   45,  116,  153,   45,  194,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    8,    8,
        8,   53,    8,  206,   53,   53,   53,   53,   53,   53,
       53,   53,   84,   84,   84,   84,   84,   84,   84,   84,
      114,   62,   62,   62,  153,   62,  154,  125,  206,   62,
      123,   62,   85,   85,   85,   85,   85,   85,   85,   85,
      143,  143,  202,   62,   62,    8,    8,    8,    8,    8,
        8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
        8,    8,    8,    9,    9,    9,    9,    9,   62,  125,

      128,  154,    9,    9,    9,   86,  128,  202,   55,   55,
      136,  161,   55,   55,  185,  136,    9,  101,  101,  101,
      101,  101,  101,   86,  155,  155,  198,  185,   87,  584,
       55,   87,   87,   87,   87,   87,   87,   87,   87,  198,
        9,   10,   10,   10,   10,   10,  582,  171,   86,  284,
       10,   10,   10,   55,  161,   89,  171,   89,   89,  222,
      568,   89,   89,  222,   10,   89,  213,   95,   95,   95,
       95,   95,   95,   95,   95,  213,   92,   92,   89,   89,
       92,   92,  192,  195,  284,  195,  512,  192,   10,   19,
       99,   99,   99,   99,   99,   99,   99,   99,   92,   19,

       95,  221,   19,   19,   19,   19,   19,   19,   19,   19,
       26,  191,   26,   26,   26,   26,   26,   26,   26,   26,
       26,   92,  237,  221,   26,   26,   26,   26,   26,  100,
      100,  100,  100,  100,  100,  100,  100,  131,  131,  131,
      131,  131,  131,  131,  131,   26,  512,   26,   26,   26,
       26,   26,   26,   32,  146,  238,  238,  146,  146,   32,
      567,  191,   32,   32,  146,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,  146,  237,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,

       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   35,
       35,   35,   35,   35,   35,   35,   35,   35,  210,  210,
      210,   35,   35,   35,   35,   35,  109,  231,  240,  241,
       35,  109,  252,  231,  109,  241,  109,  117,  565,  150,
      150,  252,  239,  240,   35,   35,   35,   35,   35,   35,
       42,   42,   42,   42,   42,  293,   42,   42,  133,  133,
       42,  265,  133,  133,  293,  117,  117,  239,  281,  117,
      388,  388,   42,   42,   42,   46,  117,  163,  281,  117,
      133,  163,  323,  265,  239,   46,  150,  163,   46,   46,

       46,   46,   46,   46,   46,   46,  275,  282,  323,  163,
      163,  275,  282,  133,  142,  142,  142,  142,  142,  142,
      142,  142,  159,  159,  159,  159,  159,  159,  159,  159,
      160,  160,  160,  160,  160,  160,  160,  160,  438,  438,
       46,   63,  201,  201,  201,  201,  201,  201,  201,  201,
      279,   63,  564,  280,   63,   63,   63,   63,   63,   63,
       63,   63,   79,  560,   79,   79,   79,  297,   79,   79,
      254,  254,   79,  197,  280,  201,  297,  197,  256,  256,
      254,  321,  322,  197,   79,   79,   79,   91,  256,   91,
       91,   91,  322,   91,   91,  197,  197,   91,  209,  209,

      209,  209,  209,  209,  209,  209,  209,  298,  298,   91,
       91,   91,   94,  279,   94,   94,   94,  298,   94,   94,
      313,  383,   94,  162,  313,  162,  162,  452,  452,  162,
      162,  383,  321,  162,   94,   94,   94,   96,   96,   96,
       96,   96,   96,   96,   96,  162,  162,  162,  312,   96,
       96,   96,   96,   96,  205,  368,  205,  205,  205,  205,
      205,  205,  214,  214,  214,  214,  214,  214,  214,  214,
      312,  368,   96,   96,   96,   96,   96,   96,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  316,  371,  205,
      104,  104,  104,  104,  104,  216,  216,  216,  216,  216,

      216,  216,  216,  217,  217,  217,  217,  217,  217,  316,
      299,  299,  373,  104,  104,  104,  104,  104,  104,  135,
      299,  135,  135,  135,  549,  135,  135,  373,  219,  135,
      219,  219,  219,  219,  219,  219,  219,  219,  453,  453,
      371,  135,  135,  135,  164,  545,  164,  164,  164,  164,
      164,  164,  164,  164,  247,  247,  247,  247,  247,  247,
      247,  247,  247,  253,  253,  253,  253,  253,  253,  253,
      253,  255,  255,  255,  255,  255,  255,  255,  255,  164,
      165,  541,  165,  165,  165,  165,  165,  165,  165,  165,
      259,  259,  259,  259,  259,  259,  259,  259,  419,  419,

      259,  261,  261,  261,  261,  261,  261,  261,  261,  262,
      262,  262,  262,  262,  262,  165,  166,  529,  166,  166,
      166,  166,  166,  166,  166,  166,  264,  317,  264,  264,
      264,  264,  264,  264,  264,  264,  301,  301,  283,  283,
      283,  283,  283,  283,  283,  283,  301,  456,  456,  317,
      419,  166,  167,  318,  167,  167,  167,  167,  167,  167,
      167,  167,  318,  324,  342,  343,  167,  167,  167,  167,
      167,  283,  324,  342,  343,  344,  344,  287,  372,  287,
      287,  287,  287,  287,  287,  344,  420,  372,  420,  167,
      167,  167,  167,  167,  167,  170,  170,  170,  170,  170,

      170,  170,  170,  170,  345,  345,  528,  170,  170,  170,
      170,  170,  287,  294,  345,  294,  294,  294,  294,  294,
      294,  294,  294,  307,  307,  307,  307,  307,  307,  513,
      170,  170,  170,  170,  170,  170,  172,  172,  172,  172,
      172,  172,  172,  172,  172,  172,  467,  467,  509,  172,
      172,  172,  172,  172,  295,  376,  295,  295,  295,  295,
      295,  295,  295,  295,  300,  300,  300,  300,  300,  300,
      300,  300,  172,  172,  172,  172,  172,  172,  173,  173,
      173,  173,  173,  173,  173,  173,  347,  347,  508,  376,
      173,  173,  173,  173,  173,  296,  347,  296,  296,  296,

      296,  296,  296,  296,  296,  306,  306,  306,  306,  306,
      306,  306,  306,  173,  173,  173,  173,  173,  173,  203,
      507,  203,  203,  203,  203,  203,  203,  203,  203,  304,
      304,  304,  304,  304,  304,  304,  304,  506,  309,  304,
      309,  309,  309,  309,  309,  309,  309,  309,  334,  334,
      334,  334,  334,  334,  203,  204,  501,  204,  204,  204,
      204,  204,  204,  204,  204,  331,  331,  331,  331,  331,
      331,  331,  331,  333,  333,  333,  333,  333,  333,  333,
      333,  337,  337,  337,  337,  337,  337,  337,  337,  358,
      204,  215,  215,  215,  215,  215,  215,  215,  215,  215,

      215,  215,  491,  491,  484,  215,  215,  215,  215,  215,
      336,  358,  336,  336,  336,  336,  336,  336,  336,  336,
      341,  483,  341,  341,  341,  341,  341,  341,  215,  215,
      215,  215,  215,  215,  218,  218,  218,  218,  218,  218,
      218,  218,  218,  218,  397,  502,  502,  218,  218,  218,
      218,  218,  339,  397,  339,  339,  339,  339,  339,  339,
      339,  339,  346,  346,  346,  346,  346,  346,  346,  346,
      218,  218,  218,  218,  218,  218,  242,  479,  242,  242,
      242,  242,  242,  242,  242,  242,  340,  364,  340,  340,
      340,  340,  340,  340,  340,  340,  350,  350,  350,  350,

      350,  350,  350,  350,  398,  670,  350,  510,  510,  364,
      670,  242,  243,  398,  243,  243,  243,  243,  243,  243,
      243,  243,  352,  352,  352,  352,  352,  352,  352,  352,
      353,  353,  353,  353,  353,  353,  355,  366,  355,  355,
      355,  355,  355,  355,  355,  355,  374,  243,  244,  449,
      244,  244,  244,  244,  244,  244,  244,  244,  449,  366,
      414,  385,  374,  382,  382,  382,  382,  382,  382,  382,
      382,  385,  450,  375,  375,  375,  375,  375,  375,  375,
      375,  450,  414,  244,  257,  257,  257,  257,  257,  257,
      257,  257,  257,  257,  257,  260,  260,  260,  260,  260,

      260,  260,  260,  260,  260,  260,  375,  415,  457,  260,
      260,  260,  260,  260,  379,  379,  379,  379,  379,  379,
      379,  384,  384,  384,  384,  384,  384,  384,  384,  415,
      457,  465,  260,  260,  260,  260,  260,  260,  263,  263,
      263,  263,  263,  263,  263,  263,  263,  263,  379,  536,
      536,  263,  263,  263,  263,  263,  390,  390,  390,  390,
      390,  390,  390,  390,  391,  391,  391,  391,  391,  391,
      460,  399,  399,  459,  263,  263,  263,  263,  263,  263,
      285,  399,  285,  285,  285,  285,  285,  285,  285,  285,
      393,  432,  393,  393,  393,  393,  393,  393,  393,  393,

      394,  432,  394,  394,  394,  394,  394,  394,  394,  394,
      458,  473,  551,  551,  468,  285,  286,  433,  286,  286,
      286,  286,  286,  286,  286,  286,  395,  433,  395,  395,
      395,  395,  395,  395,  395,  395,  396,  435,  396,  396,
      396,  396,  396,  396,  396,  396,  473,  435,  461,  571,
      571,  286,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  400,  400,  445,  292,  292,  292,  292,  292,  468,
      461,  400,  401,  401,  401,  401,  401,  401,  401,  401,
      408,  408,  408,  408,  408,  408,  431,  292,  292,  292,
      292,  292,  292,  302,  302,  302,  302,  302,  302,  302,

      302,  302,  302,  302,  305,  305,  305,  305,  305,  305,
      305,  305,  305,  305,  305,  402,  402,  463,  305,  305,
      305,  305,  305,  469,  477,  402,  405,  405,  405,  405,
      405,  405,  405,  405,  427,  503,  405,  422,  469,  463,
      418,  305,  305,  305,  305,  305,  305,  308,  308,  308,
      308,  308,  308,  308,  308,  308,  308,  503,  417,  477,
      308,  308,  308,  308,  308,  407,  407,  407,  407,  407,
      407,  407,  407,  409,  416,  409,  409,  409,  409,  409,
      409,  409,  409,  308,  308,  308,  308,  308,  308,  325,
      325,  325,  325,  325,  325,  325,  325,  325,  421,  428,

      505,  428,  428,  428,  428,  428,  428,  428,  428,  434,
      434,  434,  434,  434,  434,  434,  434,  413,  421,  412,
      421,  421,  505,  325,  326,  326,  326,  326,  326,  326,
      326,  326,  326,  429,  466,  429,  429,  429,  429,  429,
      429,  429,  429,  421,  430,  485,  430,  430,  430,  430,
      430,  430,  430,  430,  466,  485,  466,  466,  326,  327,
      327,  327,  327,  327,  327,  327,  327,  327,  440,  440,
      440,  440,  440,  440,  440,  440,  441,  441,  441,  441,
      441,  441,  443,  500,  443,  443,  443,  443,  443,  443,
      443,  443,  500,  327,  332,  486,  332,  332,  332,  332,

      332,  332,  332,  332,  332,  486,  575,  575,  332,  332,
      332,  332,  332,  444,  444,  444,  444,  444,  444,  444,
      444,  446,  411,  446,  446,  446,  446,  446,  446,  446,
      446,  332,  332,  332,  332,  332,  332,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  588,  588,  410,  335,
      335,  335,  335,  335,  447,  488,  447,  447,  447,  447,
      447,  447,  447,  447,  448,  488,  448,  448,  448,  448,
      448,  448,  335,  335,  335,  335,  335,  335,  348,  348,
      348,  348,  348,  348,  348,  348,  348,  348,  348,  351,
      351,  351,  351,  351,  351,  351,  351,  351,  351,  351,

      451,  451,  381,  351,  351,  351,  351,  351,  555,  470,
      451,  470,  470,  470,  471,  530,  471,  471,  471,  494,
      494,  494,  494,  494,  494,  530,  351,  351,  351,  351,
      351,  351,  354,  354,  354,  354,  354,  354,  354,  354,
      354,  531,  533,  555,  566,  354,  354,  354,  354,  354,
      380,  531,  533,  370,  566,  369,  470,  363,  591,  362,
      476,  471,  476,  476,  476,  476,  476,  476,  354,  354,
      354,  354,  354,  354,  377,  377,  377,  377,  377,  377,
      377,  377,  377,  546,  548,  472,  472,  472,  472,  472,
      472,  472,  472,  591,  361,  476,  478,  478,  478,  478,

      478,  478,  478,  478,  360,  546,  548,  357,  377,  378,
      378,  378,  378,  378,  378,  378,  378,  378,  472,  480,
      572,  480,  480,  480,  480,  480,  480,  480,  480,  481,
      356,  481,  481,  481,  481,  481,  481,  481,  481,  619,
      619,  338,  572,  378,  386,  574,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  389,  330,  389,  389,  389,
      389,  389,  389,  389,  389,  389,  329,  574,  585,  389,
      389,  389,  389,  389,  482,  328,  482,  482,  482,  482,
      482,  482,  487,  487,  487,  487,  487,  487,  487,  487,
      585,  320,  389,  389,  389,  389,  389,  389,  392,  392,

      392,  392,  392,  392,  392,  392,  392,  319,  315,  314,
      392,  392,  392,  392,  392,  493,  493,  493,  493,  493,
      493,  493,  493,  496,  311,  496,  496,  496,  496,  496,
      496,  496,  496,  392,  392,  392,  392,  392,  392,  403,
      403,  403,  403,  403,  403,  403,  403,  403,  403,  403,
      406,  406,  406,  406,  406,  406,  406,  406,  406,  406,
      310,  291,  290,  289,  406,  406,  406,  406,  406,  497,
      497,  497,  497,  497,  497,  497,  497,  497,  498,  498,
      498,  498,  498,  498,  498,  498,  498,  406,  406,  406,
      406,  406,  406,  423,  288,  423,  423,  423,  423,  423,

      423,  423,  423,  499,  499,  499,  499,  499,  499,  499,
      499,  499,  514,  278,  514,  514,  514,  277,  276,  515,
      274,  515,  515,  515,  273,  272,  271,  270,  423,  424,
      269,  424,  424,  424,  424,  424,  424,  424,  424,  516,
      268,  516,  516,  516,  517,  267,  517,  517,  517,  251,
      520,  250,  520,  520,  520,  249,  248,  246,  245,  514,
      236,  235,  234,  233,  424,  425,  515,  425,  425,  425,
      425,  425,  425,  425,  425,  518,  232,  229,  518,  518,
      518,  518,  518,  518,  518,  518,  516,  227,  226,  225,
      224,  517,  223,  220,  212,  519,  519,  520,  211,  519,

      425,  426,  208,  426,  426,  426,  426,  426,  426,  426,
      426,  519,  519,  519,  521,  521,  207,  525,  521,  525,
      525,  525,  525,  525,  525,  525,  525,  200,  199,  193,
      521,  521,  521,  190,  189,  188,  426,  436,  187,  436,
      436,  436,  436,  436,  436,  436,  436,  436,  439,  186,
      439,  439,  439,  439,  439,  439,  439,  439,  439,  184,
      183,  182,  439,  439,  439,  439,  439,  526,  181,  526,
      526,  526,  526,  526,  526,  526,  526,  532,  532,  532,
      532,  532,  532,  532,  532,  439,  439,  439,  439,  439,
      439,  442,  442,  442,  442,  442,  442,  442,  442,  442,

      180,  179,  178,  442,  442,  442,  442,  442,  527,  177,
      527,  527,  527,  527,  527,  527,  527,  527,  538,  538,
      538,  538,  538,  538,  538,  538,  442,  442,  442,  442,
      442,  442,  454,  454,  454,  454,  454,  454,  454,  454,
      454,  454,  474,  176,  474,  474,  474,  474,  474,  474,
      474,  474,  539,  539,  539,  539,  539,  539,  540,  175,
      540,  540,  540,  540,  540,  540,  540,  540,  542,  542,
      542,  542,  542,  542,  542,  542,  542,  474,  475,  169,
      475,  475,  475,  475,  475,  475,  475,  475,  543,  543,
      543,  543,  543,  543,  543,  543,  543,  544,  544,  544,

      544,  544,  544,  544,  552,  552,  552,  552,  552,  552,
      552,  552,  168,  475,  489,  158,  489,  489,  489,  489,
      489,  489,  489,  489,  489,  492,  157,  492,  492,  492,
      492,  492,  492,  492,  492,  492,  156,  152,  151,  492,
      492,  492,  492,  492,  553,  553,  553,  553,  553,  553,
      553,  553,  554,  554,  554,  554,  554,  554,  554,  554,
      149,  145,  492,  492,  492,  492,  492,  492,  495,  495,
      495,  495,  495,  495,  495,  495,  138,  134,  132,  130,
      495,  495,  495,  495,  495,  554,  558,  122,  558,  558,
      558,  558,  558,  558,  559,  559,  559,  559,  559,  559,

      559,  559,  121,  495,  495,  495,  495,  495,  495,  522,
      120,  522,  522,  522,  522,  522,  522,  522,  522,  119,
      561,  558,  561,  561,  561,  561,  561,  561,  561,  561,
      562,  118,  562,  562,  562,  562,  562,  562,  562,  562,
      113,  112,  111,  110,  522,  523,  108,  523,  523,  523,
      523,  523,  523,  523,  523,  563,  107,  563,  563,  563,
      563,  563,  563,  569,  106,  569,  569,  569,  569,  569,
      569,  569,  569,  598,  598,  598,  598,  598,  598,  102,
      523,  524,   98,  524,  524,  524,  524,  524,  524,  524,
      524,  579,  579,  579,  579,  579,  579,  579,  579,  580,

      580,  580,  580,  580,  580,  580,  580,  581,  581,  581,
      581,  581,  581,  581,  581,   97,  524,  534,   93,  534,
      534,  534,  534,  534,  534,  534,  534,  534,  537,   90,
      537,  537,  537,  537,  537,  537,  537,  537,   82,   81,
       80,   78,  537,  537,  537,  537,  537,   73,  590,  590,
      590,  590,  590,  590,  590,  590,  594,   66,  594,  594,
      594,  594,  594,  594,   59,  537,  537,  537,  537,  537,
      537,  556,   54,  556,  556,  556,  556,  556,  556,  556,
      556,  590,  596,  596,  596,  596,  596,  596,  596,  596,
       51,  594,  597,  597,  597,  597,  597,  597,  597,  597,

       49,   41,   40,   39,   38,   37,  556,  557,   36,  557,
      557,  557,  557,  557,  557,  557,  557,   33,   29,   23,
      600,  600,  600,  600,  600,  600,  600,  600,  601,  601,
      601,  601,  601,  601,  601,  601,   17,   15,   14,   13,
        0,    0,  557,  576,    0,  576,  576,  576,  576,  576,
      576,  576,  576,  600,    0,    0,    0,    0,    0,    0,
        0,  601,  602,  602,  602,  602,  602,  602,  602,  602,
      604,  604,  604,  604,  604,  604,  604,  604,  576,  577,
        0,  577,  577,  577,  577,  577,  577,  577,  577,    0,
        0,    0,    0,    0,    0,  602,  605,  605,  605,  605,

      605,  605,    0,  604,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  577,  578,    0,  578,  578,  578,
      578,  578,  578,  578,  578,    0,    0,    0,    0,  605,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      578,  592,    0,  592,  592,  592,  592,  592,  592,  592,
      592,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,  592,  593,    0,  593,
      593,  593,  593,  593,  593,  593,  593,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  593,  607,  607,  607,  607,  607,  607,  607,
      607,  607,  607,  607,  607,  607,  607,  607,  607,  608,
      608,  608,  608,  608,  608,  608,  608,  608,  608,  608,
      608,  608,  608,  608,  608,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  609,  609,  609,  609,
      609,  610,  610,  610,  610,  610,  610,  610,  610,  610,
      610,  610,  610,  610,  610,  610,  610,  611,    0,    0,
        0,    0,    0,    0,    0,  611,  611,  611,    0,    0,

      611,  611,  611,  612,  612,  612,  612,  612,  612,  612,
      612,  612,  612,  612,  612,  612,  612,  612,  612,  613,
        0,    0,    0,    0,  613,    0,    0,  613,  613,  613,
      613,    0,  613,  613,  613,  614,    0,    0,    0,    0,
        0,    0,    0,  614,  614,  614,    0,    0,  614,  614,
      614,  615,    0,    0,  615,  615,    0,  615,    0,  615,
      615,  615,    0,    0,  615,  615,  615,  616,  616,    0,
        0,    0,  616,  617,    0,    0,  617,  617,    0,  617,
        0,  617,  617,  617,    0,    0,  617,  617,  617,  618,
        0,    0,  618,  618,    0,  618,    0,  618,  618,  618,

        0,  618,    0,  618,  618,  620,    0,    0,  620,    0,
        0,  620,    0,  620,  620,  620,  620,    0,  620,  620,
      620,  621,  621,  621,  621,  621,  621,  621,  621,  621,
      621,  621,  621,  621,  621,  621,  621,  622,  622,    0,
      622,    0,  622,  622,  622,  622,  622,  622,  622,  622,
      622,  622,  622,  623,  623,  623,  623,  623,  623,  623,
      623,  623,  623,  623,  623,  623,  623,  623,  623,  624,
      624,    0,  624,  624,  624,  624,  624,  624,  624,  624,
      624,  624,  624,  624,  624,  625,    0,    0,    0,    0,
      625,    0,    0,  625,  625,  625,    0,    0,  625,  625,

      625,  626,    0,    0,  626,  626,    0,  626,    0,  626,
      626,  626,    0,    0,  626,  626,  626,  627,  627,    0,
        0,    0,  627,  628,  628,  628,    0,    0,    0,  628,
      629,    0,    0,  629,  629,    0,  629,    0,  629,  629,
      629,    0,    0,  629,  629,  629,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630,  631,  631,    0,    0,    0,  631,  632,  632,
      632,    0,    0,    0,  632,  633,  633,    0,    0,    0,
      633,  634,  634,    0,    0,    0,  634,  635,  635,    0,
        0,    0,  635,  636,  636,  636,    0,    0,    0,  636,

      637,  637,    0,    0,    0,  637,  638,  638,    0,    0,
        0,  638,  639,  639,    0,    0,    0,  639,  640,  640,
      640,    0,    0,    0,  640,  641,  641,  641,  641,    0,
        0,    0,  641,  642,  642,    0,    0,    0,  642,  643,
      643,    0,    0,    0,  643,  644,  644,    0,    0,    0,
      644,  645,  645,  645,    0,    0,    0,  645,  646,  646,
      646,  646,    0,    0,    0,  646,  647,  647,    0,    0,
        0,  647,  648,  648,    0,    0,    0,  648,  649,  649,
      649,    0,    0,    0,  649,  650,  650,  650,  650,    0,
        0,    0,  650,  651,  651,    0,    0,    0,  651,  652,

        0,  652,  652,    0,    0,    0,  652,  653,  653,  653,
        0,    0,    0,  653,  654,  654,  654,  654,    0,    0,
        0,  654,  655,  655,    0,    0,    0,  655,  656,    0,
      656,  656,    0,    0,    0,  656,  657,  657,  657,    0,
        0,    0,  657,  658,  658,  658,    0,    0,    0,    0,
      658,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  660,  660,    0,
      660,  660,  660,    0,    0,  660,  660,  660,    0,    0,
      660,  660,  660,  661,  661,    0,  661,  661,  661,    0,
        0,  661,  661,  661,    0,    0,  661,  661,  661,  662,

      662,    0,    0,    0,  662,  663,    0,  663,  663,    0,
        0,    0,  663,  664,  664,    0,    0,    0,    0,  664,
      665,  665,    0,    0,    0,  665,  666,    0,  666,  666,
        0,    0,    0,  666,  667,  667,    0,    0,    0,  667,
      668,    0,  668,    0,    0,    0,    0,  668,  669,  669,
      669,  669,  669,  669,  669,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,

      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "toke.l"
#define INITIAL 0
#line 2 "toke.l"
/*
 * Copyright (c) 1996, 1998-2005, 2007-2012
 *	Todd C. Miller <Todd.Miller@courtesan.com>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Sponsored in part by the Defense Advanced Research Projects
 * Agency (DARPA) and Air Force Research Laboratory, Air Force
 * Materiel Command, USAF, under agreement number F39502-99-1-0512.
 */

#include <config.h>

#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <stddef.h>
#else
# ifdef HAVE_STDLIB_H
#  include <stdlib.h>
# endif
#endif /* STDC_HEADERS */
#ifdef HAVE_STRING_H
# include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
# include <strings.h>
#endif /* HAVE_STRINGS_H */
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif /* HAVE_UNISTD_H */
#if defined(HAVE_MALLOC_H) && !defined(STDC_HEADERS)
# include <malloc.h>
#endif /* HAVE_MALLOC_H && !STDC_HEADERS */
#ifdef HAVE_DIRENT_H
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)
#else
# define dirent direct
# define NAMLEN(dirent) (dirent)->d_namlen
# ifdef HAVE_SYS_NDIR_H
#  include <sys/ndir.h>
# endif
# ifdef HAVE_SYS_DIR_H
#  include <sys/dir.h>
# endif
# ifdef HAVE_NDIR_H
#  include <ndir.h>
# endif
#endif
#include <errno.h>
#include <ctype.h>
#include "sudoers.h"
#include "parse.h"
#include "toke.h"
#include <gram.h>
#include "lbuf.h"
#include "secure_path.h"

extern YYSTYPE yylval;
extern bool parse_error;
extern bool sudoers_warnings;
int sudolineno;
int last_token;
char *sudoers;

/* Default sudoers path, mode and owner (may be set via sudo.conf) */
const char *sudoers_file = _PATH_SUDOERS;
mode_t sudoers_mode = SUDOERS_MODE;
uid_t sudoers_uid = SUDOERS_UID;
gid_t sudoers_gid = SUDOERS_GID;

static bool continued, sawspace;
static int prev_state;

static bool _push_include(char *, bool);
static bool pop_include(void);
static char *parse_include(char *);

static int sudoers_trace_print(const char *msg);
int (*trace_print)(const char *msg) = sudoers_trace_print;

#define LEXRETURN(n)	do {	\
	last_token = (n);	\
	return (n);		\
} while (0)

#define ECHO	ignore_result(fwrite(yytext, yyleng, 1, yyout))

#define	push_include(_p)	(_push_include((_p), false))
#define	push_includedir(_p)	(_push_include((_p), true))
#define YY_NO_INPUT 1
#define YY_NO_UNPUT 1
#define GOTDEFS 1

#define GOTCMND 2

#define STARTDEFS 3

#define INDEFS 4

#define INSTR 5

#line 1525 "lex.yy.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if defined(YY_STACK_USED) && YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#ifdef __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		yy_current_buffer->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

#line 133 "toke.l"

#line 1681 "lex.yy.c"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 607 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 3665 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 134 "toke.l"
{
			    LEXTRACE(", ");
			    LEXRETURN(',');
			}			/* return ',' */
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 139 "toke.l"
BEGIN STARTDEFS;
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 141 "toke.l"
{
			    BEGIN INDEFS;
			    LEXTRACE("DEFVAR ");
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXRETURN(DEFVAR);
			}
	YY_BREAK

case 4:
YY_RULE_SETUP
#line 150 "toke.l"
{
			    BEGIN STARTDEFS;
			    LEXTRACE(", ");
			    LEXRETURN(',');
			}			/* return ',' */
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 156 "toke.l"
{
			    LEXTRACE("= ");
			    LEXRETURN('=');
			}			/* return '=' */
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 161 "toke.l"
{
			    LEXTRACE("+= ");
			    LEXRETURN('+');
			}			/* return '+' */
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 166 "toke.l"
{
			    LEXTRACE("-= ");
			    LEXRETURN('-');
			}			/* return '-' */
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 171 "toke.l"
{
			    LEXTRACE("BEGINSTR ");
			    yylval.string = NULL;
			    prev_state = YY_START;
			    BEGIN INSTR;
			}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 178 "toke.l"
{
			    LEXTRACE("WORD(2) ");
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXRETURN(WORD);
			}
	YY_BREAK


case 10:
YY_RULE_SETUP
#line 187 "toke.l"
{
			    /* Line continuation char followed by newline. */
			    sudolineno++;
			    continued = true;
			}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 193 "toke.l"
{
			    LEXTRACE("ENDSTR ");
			    BEGIN prev_state;

			    if (yylval.string == NULL) {
				LEXTRACE("ERROR "); /* empty string */
				LEXRETURN(ERROR);
			    }
			    if (prev_state == INITIAL) {
				switch (yylval.string[0]) {
				case '%':
				    if (yylval.string[1] == '\0' ||
					(yylval.string[1] == ':' &&
					yylval.string[2] == '\0')) {
					LEXTRACE("ERROR "); /* empty group */
					LEXRETURN(ERROR);
				    }
				    LEXTRACE("USERGROUP ");
				    LEXRETURN(USERGROUP);
				case '+':
				    if (yylval.string[1] == '\0') {
					LEXTRACE("ERROR "); /* empty netgroup */
					LEXRETURN(ERROR);
				    }
				    LEXTRACE("NETGROUP ");
				    LEXRETURN(NETGROUP);
				}
			    }
			    LEXTRACE("WORD(4) ");
			    LEXRETURN(WORD);
			}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 225 "toke.l"
{
			    LEXTRACE("BACKSLASH ");
			    if (!append(yytext, yyleng))
				yyterminate();
			}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 231 "toke.l"
{
			    LEXTRACE("STRBODY ");
			    if (!append(yytext, yyleng))
				yyterminate();
			}
	YY_BREAK


case 14:
YY_RULE_SETUP
#line 239 "toke.l"
{
			    /* quoted fnmatch glob char, pass verbatim */
			    LEXTRACE("QUOTEDCHAR ");
			    if (!fill_args(yytext, 2, sawspace))
				yyterminate();
			    sawspace = false;
			}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 247 "toke.l"
{
			    /* quoted sudoers special char, strip backslash */
			    LEXTRACE("QUOTEDCHAR ");
			    if (!fill_args(yytext + 1, 1, sawspace))
				yyterminate();
			    sawspace = false;
			}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 255 "toke.l"
{
			    BEGIN INITIAL;
			    yyless(0);
			    LEXRETURN(COMMAND);
			}			/* end of command line args */
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 261 "toke.l"
{
			    LEXTRACE("ARG ");
			    if (!fill_args(yytext, yyleng, sawspace))
				yyterminate();
			    sawspace = false;
			}			/* a command line arg */
	YY_BREAK

case 18:
YY_RULE_SETUP
#line 269 "toke.l"
{
			    char *path;

			    if (continued) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }

			    if ((path = parse_include(yytext)) == NULL)
				yyterminate();

			    LEXTRACE("INCLUDE\n");

			    /* Push current buffer and switch to include file */
			    if (!push_include(path))
				yyterminate();
			}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 287 "toke.l"
{
			    char *path;

			    if (continued) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }

			    if ((path = parse_include(yytext)) == NULL)
				yyterminate();

			    LEXTRACE("INCLUDEDIR\n");

			    /*
			     * Push current buffer and switch to include file.
			     * We simply ignore empty directories.
			     */
			    if (!push_includedir(path) && parse_error)
				yyterminate();
			}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 308 "toke.l"
{
			    char deftype;
			    int n;

			    if (continued) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }

			    for (n = 0; isblank((unsigned char)yytext[n]); n++)
				continue;
			    n += sizeof("Defaults") - 1;
			    if ((deftype = yytext[n++]) != '\0') {
				while (isblank((unsigned char)yytext[n]))
				    n++;
			    }
			    BEGIN GOTDEFS;
			    switch (deftype) {
				case ':':
				    yyless(n);
				    LEXTRACE("DEFAULTS_USER ");
				    LEXRETURN(DEFAULTS_USER);
				case '>':
				    yyless(n);
				    LEXTRACE("DEFAULTS_RUNAS ");
				    LEXRETURN(DEFAULTS_RUNAS);
				case '@':
				    yyless(n);
				    LEXTRACE("DEFAULTS_HOST ");
				    LEXRETURN(DEFAULTS_HOST);
				case '!':
				    yyless(n);
				    LEXTRACE("DEFAULTS_CMND ");
				    LEXRETURN(DEFAULTS_CMND);
				default:
				    LEXTRACE("DEFAULTS ");
				    LEXRETURN(DEFAULTS);
			    }
			}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 348 "toke.l"
{
			    int n;

			    if (continued) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }

			    for (n = 0; isblank((unsigned char)yytext[n]); n++)
				continue;
			    switch (yytext[n]) {
				case 'H':
				    LEXTRACE("HOSTALIAS ");
				    LEXRETURN(HOSTALIAS);
				case 'C':
				    LEXTRACE("CMNDALIAS ");
				    LEXRETURN(CMNDALIAS);
				case 'U':
				    LEXTRACE("USERALIAS ");
				    LEXRETURN(USERALIAS);
				case 'R':
				    LEXTRACE("RUNASALIAS ");
				    LEXRETURN(RUNASALIAS);
			    }
			}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 374 "toke.l"
{
				/* cmnd does not require passwd for this user */
			    	LEXTRACE("NOPASSWD ");
			    	LEXRETURN(NOPASSWD);
			}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 380 "toke.l"
{
				/* cmnd requires passwd for this user */
			    	LEXTRACE("PASSWD ");
			    	LEXRETURN(PASSWD);
			}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 386 "toke.l"
{
			    	LEXTRACE("NOEXEC ");
			    	LEXRETURN(NOEXEC);
			}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 391 "toke.l"
{
			    	LEXTRACE("EXEC ");
			    	LEXRETURN(EXEC);
			}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 396 "toke.l"
{
			    	LEXTRACE("SETENV ");
			    	LEXRETURN(SETENV);
			}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 401 "toke.l"
{
			    	LEXTRACE("NOSETENV ");
			    	LEXRETURN(NOSETENV);
			}
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 406 "toke.l"
{
			    	LEXTRACE("LOG_OUTPUT ");
			    	LEXRETURN(LOG_OUTPUT);
			}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 411 "toke.l"
{
			    	LEXTRACE("NOLOG_OUTPUT ");
			    	LEXRETURN(NOLOG_OUTPUT);
			}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 416 "toke.l"
{
			    	LEXTRACE("LOG_INPUT ");
			    	LEXRETURN(LOG_INPUT);
			}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 421 "toke.l"
{
			    	LEXTRACE("NOLOG_INPUT ");
			    	LEXRETURN(NOLOG_INPUT);
			}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 426 "toke.l"
{
			    /* empty group or netgroup */
			    LEXTRACE("ERROR ");
			    LEXRETURN(ERROR);
			}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 432 "toke.l"
{
			    /* netgroup */
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("NETGROUP ");
			    LEXRETURN(NETGROUP);
			}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 440 "toke.l"
{
			    /* group */
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("USERGROUP ");
			    LEXRETURN(USERGROUP);
			}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 448 "toke.l"
{
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("NTWKADDR ");
			    LEXRETURN(NTWKADDR);
			}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 455 "toke.l"
{
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("NTWKADDR ");
			    LEXRETURN(NTWKADDR);
			}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 462 "toke.l"
{
			    if (!ipv6_valid(yytext)) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("NTWKADDR ");
			    LEXRETURN(NTWKADDR);
			}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 473 "toke.l"
{
			    if (!ipv6_valid(yytext)) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("NTWKADDR ");
			    LEXRETURN(NTWKADDR);
			}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 484 "toke.l"
{
			    LEXTRACE("ALL ");
			    LEXRETURN(ALL);

			}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 490 "toke.l"
{
#ifdef HAVE_SELINUX
			    LEXTRACE("ROLE ");
			    LEXRETURN(ROLE);
#else
			    goto got_alias;
#endif
			}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 499 "toke.l"
{
#ifdef HAVE_SELINUX
			    LEXTRACE("TYPE ");
			    LEXRETURN(TYPE);
#else
			    goto got_alias;
#endif
			}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 508 "toke.l"
{
#ifndef HAVE_SELINUX
			got_alias:
#endif
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("ALIAS ");
			    LEXRETURN(ALIAS);
			}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 518 "toke.l"
{
			    /* no command args allowed for Defaults!/path */
			    if (!fill_cmnd(yytext, yyleng))
				yyterminate();
			    LEXTRACE("COMMAND ");
			    LEXRETURN(COMMAND);
			}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 526 "toke.l"
{
			    BEGIN GOTCMND;
			    LEXTRACE("COMMAND ");
			    if (!fill_cmnd(yytext, yyleng))
				yyterminate();
			}			/* sudo -e */
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 533 "toke.l"
{
			    /* directories can't have args... */
			    if (yytext[yyleng - 1] == '/') {
				LEXTRACE("COMMAND ");
				if (!fill_cmnd(yytext, yyleng))
				    yyterminate();
				LEXRETURN(COMMAND);
			    } else {
				BEGIN GOTCMND;
				LEXTRACE("COMMAND ");
				if (!fill_cmnd(yytext, yyleng))
				    yyterminate();
			    }
			}			/* a pathname */
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 548 "toke.l"
{
			    LEXTRACE("BEGINSTR ");
			    yylval.string = NULL;
			    prev_state = YY_START;
			    BEGIN INSTR;
			}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 555 "toke.l"
{
			    /* a word */
			    if (!fill(yytext, yyleng))
				yyterminate();
			    LEXTRACE("WORD(5) ");
			    LEXRETURN(WORD);
			}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 563 "toke.l"
{
			    LEXTRACE("( ");
			    LEXRETURN('(');
			}
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 568 "toke.l"
{
			    LEXTRACE(") ");
			    LEXRETURN(')');
			}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 573 "toke.l"
{
			    LEXTRACE(", ");
			    LEXRETURN(',');
			}			/* return ',' */
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 578 "toke.l"
{
			    LEXTRACE("= ");
			    LEXRETURN('=');
			}			/* return '=' */
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 583 "toke.l"
{
			    LEXTRACE(": ");
			    LEXRETURN(':');
			}			/* return ':' */
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 588 "toke.l"
{
			    if (yyleng & 1) {
				LEXTRACE("!");
				LEXRETURN('!');	/* return '!' */
			    }
			}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 595 "toke.l"
{
			    if (YY_START == INSTR) {
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);	/* line break in string */
			    }
			    BEGIN INITIAL;
			    sudolineno++;
			    continued = false;
			    LEXTRACE("\n");
			    LEXRETURN(COMMENT);
			}			/* return newline */
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 607 "toke.l"
{			/* throw away space/tabs */
			    sawspace = true;	/* but remember for fill_args */
			}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 611 "toke.l"
{
			    sawspace = true;	/* remember for fill_args */
			    sudolineno++;
			    continued = true;
			}			/* throw away EOL after \ */
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 617 "toke.l"
{
			    BEGIN INITIAL;
			    sudolineno++;
			    continued = false;
			    LEXTRACE("#\n");
			    LEXRETURN(COMMENT);
			}			/* comment, not uid/gid */
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 625 "toke.l"
{
			    LEXTRACE("ERROR ");
			    LEXRETURN(ERROR);
			}	/* parse error */
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(GOTDEFS):
case YY_STATE_EOF(GOTCMND):
case YY_STATE_EOF(STARTDEFS):
case YY_STATE_EOF(INDEFS):
case YY_STATE_EOF(INSTR):
#line 630 "toke.l"
{
			    if (YY_START != INITIAL) {
			    	BEGIN INITIAL;
				LEXTRACE("ERROR ");
				LEXRETURN(ERROR);
			    }
			    if (!pop_include())
				yyterminate();
			}
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 640 "toke.l"
ECHO;
	YY_BREAK
#line 2457 "lex.yy.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 607 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;
	register char *yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 607 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 606);

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;

	yy_current_buffer->yy_at_bol = (c == '\n');

	return c;
	}
#endif	/* ifndef YY_NO_INPUT */


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}


#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
#include <unistd.h>
#endif
#endif

#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	int oerrno = errno;

	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if defined(YY_ALWAYS_INTERACTIVE) && YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if defined(YY_NEVER_INTERACTIVE) && YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	errno = oerrno;
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if defined(YY_MAIN) && YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 640 "toke.l"

struct path_list {
    char *path;
    struct path_list *next;
};

struct include_stack {
    YY_BUFFER_STATE bs;
    char *path;
    struct path_list *more; /* more files in case of includedir */
    int lineno;
    bool keepopen;
};

static int
pl_compare(const void *v1, const void *v2)
{
    const struct path_list * const *p1 = v1;
    const struct path_list * const *p2 = v2;

    return strcmp((*p1)->path, (*p2)->path);
}

static char *
switch_dir(struct include_stack *stack, char *dirpath)
{
    DIR *dir;
    int i, count = 0;
    char *path = NULL;
    struct dirent *dent;
    struct stat sb;
    struct path_list *pl, *first = NULL;
    struct path_list **sorted = NULL;
    debug_decl(switch_dir, SUDO_DEBUG_PARSER)

    if (!(dir = opendir(dirpath))) {
	if (errno != ENOENT) {
	    char *errbuf;
	    if (asprintf(&errbuf, _("%s: %s"), dirpath, strerror(errno)) != -1) {
		yyerror(errbuf);
		free(errbuf);
	    } else {
		yyerror(_("unable to allocate memory"));
	    }
	}
	goto done;
    }
    while ((dent = readdir(dir))) {
	/* Ignore files that end in '~' or have a '.' in them. */
	if (dent->d_name[0] == '\0' || dent->d_name[NAMLEN(dent) - 1] == '~'
	    || strchr(dent->d_name, '.') != NULL) {
	    continue;
	}
	if (asprintf(&path, "%s/%s", dirpath, dent->d_name) == -1) {
	    closedir(dir);
	    goto bad;
	}
	if (stat(path, &sb) != 0 || !S_ISREG(sb.st_mode)) {
	    efree(path);
	    path = NULL;
	    continue;
	}
	pl = malloc(sizeof(*pl));
	if (pl == NULL)
	    goto bad;
	pl->path = path;
	pl->next = first;
	first = pl;
	count++;
    }
    closedir(dir);

    if (count == 0)
	goto done;

    /* Sort the list as an array. */
    sorted = malloc(sizeof(*sorted) * count);
    if (sorted == NULL)
	goto bad;
    pl = first;
    for (i = 0; i < count; i++) {
	sorted[i] = pl;
	pl = pl->next;
    }
    qsort(sorted, count, sizeof(*sorted), pl_compare);

    /* Apply sorting to the list. */
    first = sorted[0];
    sorted[count - 1]->next = NULL;
    for (i = 1; i < count; i++)
	sorted[i - 1]->next = sorted[i];
    efree(sorted);

    /* Pull out the first element for parsing, leave the rest for later. */
    if (count) {
	path = first->path;
	pl = first->next;
	efree(first);
	stack->more = pl;
    } else {
	path = NULL;
    }
done:
    efree(dirpath);
    debug_return_str(path);
bad:
    while (first != NULL) {
	pl = first;
	first = pl->next;
	free(pl->path);
	free(pl);
    }
    efree(sorted);
    efree(dirpath);
    efree(path);
    debug_return_str(NULL);
}

#define MAX_SUDOERS_DEPTH	128
#define SUDOERS_STACK_INCREMENT	16

static size_t istacksize, idepth;
static struct include_stack *istack;
static bool keepopen;

void
init_lexer(void)
{
    struct path_list *pl;
    debug_decl(init_lexer, SUDO_DEBUG_PARSER)

    while (idepth) {
	idepth--;
	while ((pl = istack[idepth].more) != NULL) {
	    istack[idepth].more = pl->next;
	    efree(pl->path);
	    efree(pl);
	}
	efree(istack[idepth].path);
	if (idepth && !istack[idepth].keepopen)
	    fclose(istack[idepth].bs->yy_input_file);
	yy_delete_buffer(istack[idepth].bs);
    }
    efree(istack);
    istack = NULL;
    istacksize = idepth = 0;
    sudolineno = 1;
    keepopen = false;
    sawspace = false;
    continued = false;
    prev_state = INITIAL;

    debug_return;
}

static bool
_push_include(char *path, bool isdir)
{
    struct path_list *pl;
    FILE *fp;
    debug_decl(_push_include, SUDO_DEBUG_PARSER)

    /* push current state onto stack */
    if (idepth >= istacksize) {
	if (idepth > MAX_SUDOERS_DEPTH) {
	    yyerror(_("too many levels of includes"));
	    debug_return_bool(false);
	}
	istacksize += SUDOERS_STACK_INCREMENT;
	istack = (struct include_stack *) realloc(istack,
	    sizeof(*istack) * istacksize);
	if (istack == NULL) {
	    yyerror(_("unable to allocate memory"));
	    debug_return_bool(false);
	}
    }
    if (isdir) {
	struct stat sb;
	switch (sudo_secure_dir(path, sudoers_uid, sudoers_gid, &sb)) {
	    case SUDO_PATH_SECURE:
		break;
	    case SUDO_PATH_MISSING:
		debug_return_bool(false);
	    case SUDO_PATH_BAD_TYPE:
		errno = ENOTDIR;
		if (sudoers_warnings) {
		    warning("%s", path);
		}
		debug_return_bool(false);
	    case SUDO_PATH_WRONG_OWNER:
		if (sudoers_warnings) {
		    warningx(_("%s is owned by uid %u, should be %u"),   
			path, (unsigned int) sb.st_uid,
			(unsigned int) sudoers_uid);
		}
		debug_return_bool(false);
	    case SUDO_PATH_WORLD_WRITABLE:
		if (sudoers_warnings) {
		    warningx(_("%s is world writable"), path);
		}
		debug_return_bool(false);
	    case SUDO_PATH_GROUP_WRITABLE:
		if (sudoers_warnings) {
		    warningx(_("%s is owned by gid %u, should be %u"),
			path, (unsigned int) sb.st_gid,
			(unsigned int) sudoers_gid);
		}
		debug_return_bool(false);
	    default:
		/* NOTREACHED */
		debug_return_bool(false);
	}
	if (!(path = switch_dir(&istack[idepth], path))) {
	    /* switch_dir() called yyerror() for us */
	    debug_return_bool(false);
	}
	while ((fp = open_sudoers(path, false, &keepopen)) == NULL) {
	    /* Unable to open path in includedir, go to next one, if any. */
	    efree(path);
	    if ((pl = istack[idepth].more) == NULL)
		debug_return_bool(false);
	    path = pl->path;
	    istack[idepth].more = pl->next;
	    efree(pl);
	}
    } else {
	if ((fp = open_sudoers(path, true, &keepopen)) == NULL) {
	    char *errbuf;
	    if (asprintf(&errbuf, _("%s: %s"), path, strerror(errno)) != -1) {
		yyerror(errbuf);
		free(errbuf);
	    } else {
		yyerror(_("unable to allocate memory"));
	    }
	    debug_return_bool(false);
	}
	istack[idepth].more = NULL;
    }
    /* Push the old (current) file and open the new one. */
    istack[idepth].path = sudoers; /* push old path */
    istack[idepth].bs = YY_CURRENT_BUFFER;
    istack[idepth].lineno = sudolineno;
    istack[idepth].keepopen = keepopen;
    idepth++;
    sudolineno = 1;
    sudoers = path;
    yy_switch_to_buffer(yy_create_buffer(fp, YY_BUF_SIZE));

    debug_return_bool(true);
}

static bool
pop_include(void)
{
    struct path_list *pl;
    FILE *fp;
    debug_decl(pop_include, SUDO_DEBUG_PARSER)

    if (idepth == 0)
	debug_return_bool(false);

    if (!keepopen)
	fclose(YY_CURRENT_BUFFER->yy_input_file);
    yy_delete_buffer(YY_CURRENT_BUFFER);
    /* If we are in an include dir, move to the next file. */
    while ((pl = istack[idepth - 1].more) != NULL) {
	fp = open_sudoers(pl->path, false, &keepopen);
	if (fp != NULL) {
	    istack[idepth - 1].more = pl->next;
	    efree(sudoers);
	    sudoers = pl->path;
	    sudolineno = 1;
	    yy_switch_to_buffer(yy_create_buffer(fp, YY_BUF_SIZE));
	    efree(pl);
	    break;
	}
	/* Unable to open path in include dir, go to next one. */
	istack[idepth - 1].more = pl->next;
	efree(pl->path);
	efree(pl);
    }
    /* If no path list, just pop the last dir on the stack. */
    if (pl == NULL) {
	idepth--;
	yy_switch_to_buffer(istack[idepth].bs);
	efree(sudoers);
	sudoers = istack[idepth].path;
	sudolineno = istack[idepth].lineno;
	keepopen = istack[idepth].keepopen;
    }
    debug_return_bool(true);
}

static char *
parse_include(char *base)
{
    char *cp, *ep, *path, *pp;
    int dirlen = 0, len = 0, subst = 0;
    size_t shost_len = 0;
    debug_decl(parse_include, SUDO_DEBUG_PARSER)

    /* Pull out path from #include line. */
    cp = base + sizeof("#include");
    if (*cp == 'i')
	cp += 3; /* includedir */
    while (isblank((unsigned char) *cp))
	cp++;
    ep = cp;
    while (*ep != '\0' && !isspace((unsigned char) *ep)) {
	if (ep[0] == '%' && ep[1] == 'h') {
	    shost_len = strlen(user_shost);
	    len += shost_len - 2;
	    subst = 1;
	}
	ep++;
    }

    /* Relative paths are located in the same dir as the sudoers file. */
    if (*cp != '/') {
	char *dirend = strrchr(sudoers, '/');
	if (dirend != NULL)
	    dirlen = (int)(dirend - sudoers) + 1;
    }

    /* Make a copy of the fully-qualified path and return it. */
    len += (int)(ep - cp);
    path = pp = malloc(len + dirlen + 1);
    if (path == NULL) {
	yyerror(_("unable to allocate memory"));
	debug_return_str(NULL);
    }
    if (dirlen) {
	memcpy(path, sudoers, dirlen);
	pp += dirlen;
    }
    if (subst) {
	/* substitute for %h */
	while (cp < ep) {
	    if (cp[0] == '%' && cp[1] == 'h') {
		memcpy(pp, user_shost, shost_len);
		pp += shost_len;
		cp += 2;
		continue;
	    }
	    *pp++ = *cp++;
	}
	*pp = '\0';
    } else {
	memcpy(pp, cp, len);
	pp[len] = '\0';
    }

    /* Push any excess characters (e.g. comment, newline) back to the lexer */
    if (*ep != '\0')
	yyless((int)(ep - base));

    debug_return_str(path);
}

#ifdef TRACELEXER
static int
sudoers_trace_print(const char *msg)
{
    return fputs(msg, stderr);
}
#else
static int
sudoers_trace_print(const char *msg)
{
    static bool initialized;
    static struct lbuf lbuf;

    if (!initialized) {
	initialized = true;
	lbuf_init(&lbuf, NULL, 0, NULL, 0);
    }

    lbuf_append(&lbuf, "%s", msg);
    /* XXX - assumes a final newline */
    if (strchr(msg, '\n') != NULL)
    {
	sudo_debug_printf2(NULL, NULL, 0, SUDO_DEBUG_PARSER|SUDO_DEBUG_DEBUG,
	    "%s:%d %s", sudoers, sudolineno, lbuf.buf);
	lbuf.len = 0;
    }
    return 0;
}
#endif /* TRACELEXER */
